#!/bin/sh
exepath=.
exename=evostreamms
existingpid=`ps -A | grep $exename | grep -v defunct | awk -F" " '{print $1}'`
if [ ! -z "$existingpid" ]
then
	echo "Evostream is already running. Process ID: $existingpid"
	exit 1
else
	echo "Launching EvoStream as" `whoami`
fi
$exepath/$exename --daemon ../config/config.lua
sleep 2
daemonpid=`ps -A | grep $exename | grep -v defunct | awk -F" " '{print $1}'`
if [ -z "$daemonpid" ]
then
	echo "Failed to launch Evostream as daemon"
	echo "Troubleshooting:"
	echo "1) Make sure you have installed the license"
	echo "2) If license is installed, try to run as console to receive more info on the startup failure"
	echo "3) If console mode fails to retrieve logs you may have an error in your main config file, try running: ./evostreamms --use-implicit-console-appender <path to config>/config.lua"
	echo "4) If all above options fail, please post your issue on our forum at https://evostream.com/question/"
else
	echo "Successfully launched Evostream as daemon. Process ID: $daemonpid"
fi
